package com.nisum.webfluxmongodbordermanagement.controller;

import com.nisum.webfluxmongodbordermanagement.entity.Order;
import com.nisum.webfluxmongodbordermanagement.service.OrdersService;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

import java.io.IOException;

@DataMongoTest
@ExtendWith(SpringExtension.class)
@ActiveProfiles("test")
@Disabled
public class OrderControllerIntTest {

    static {
        System.setProperty("spring.mongodb.embedded.version","5.0.0");
    }

    @Autowired
    WebTestClient webTestClient;
    @Autowired(required=true)
    OrdersService orderService;

    @BeforeEach
    public void setup() throws IOException {

//        mongoTemplate.getCollection("orders").drop();
//        //mongoTemplate.insert(new User("23563456", "01", "samab12344","sarika@123456","1"));
//        mongoTemplate.insert(new Order("2356781", "01", "1","ooppo122356","oppo123456","sucess"));

    }

    @Test
    public void getOrderControllerTest(@Autowired MongoTemplate mongoTemplate) {
        mongoTemplate.getCollection("orders").drop();

//        Flux<Order> result = orderService.getOrders();
//
//        StepVerifier.create(result)
//                .expectNextMatches(order -> order.getOrderId().equals("01"))
//                .expectComplete()
//                .verify();
//    }

        mongoTemplate.insert(new Order("2356781", "01", "1","ooppo122356","oppo123456","sucess"));
        Flux<Order> result = orderService.getOrders();
        Flux<Order> responseBody = webTestClient.get().uri("/orders")
            .exchange()
            .expectStatus().isOk()
            .returnResult(Order.class)
            .getResponseBody();
//
        StepVerifier.create(responseBody)
            .expectSubscription()
                .expectNextMatches(order -> order.getUserId().equals("1"))
            .verifyComplete();
}


}
